/* src/admin_user.c - commandes admins pour gerer les users
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <sys/time.h>
#include <time.h>
#include "main.h"
#include <dirent.h>

extern int dataQ;
extern int dataS;
extern struct badchans *badchead;
extern struct badnicks *badnhead;
extern struct ignore *ignorehead;
extern struct cs_commands cs_cmds[];

void cs_whois(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *user = parv[1], chans[450], b[205];
	int auth = (nick->nick == user || IsAnAdmin(nick->user)), size, first = 0;
	aNick *tmp;
	aJoin *chanl;
	anAccess *acces;
	anUser *ux;

	if(!(tmp = getnickbynick(user)))
	{
		csntc(nick, NOTCONNECTED, user);
		return;
	}

	csntc(nick, "Infos sur \2%s", tmp->nick);
	csntc(nick, " Nom: %s", tmp->name);
#ifdef HAVE_CRYPTHOST
	csntc(nick, " Mask: %s\2%s\2!\002%s\2@\002%s", GetPrefix(tmp), tmp->nick, tmp->ident, tmp->crypt);
	if(auth) csntc(nick, " Realhost: \002%s\2", tmp->host);
#else
	csntc(nick, " Mask: \2%s\2!\002%s\2@\002%s", tmp->nick, tmp->ident, IsAnAdmin(nick->user) ? tmp->host : "*");
#endif
	//csntc(nick, "IP: \002%s", dcdip(tmp->base64));
	if((tmp->flag & N_OPER)) csntc(nick, " %s est \2IRCop.", tmp->nick);
	if(auth) csntc(nick, " UserModes: \2%s\2", (tmp->modes[0] != '\0') ? tmp->modes : "Aucun");
	if(auth)
	{
		chans[0] = '\0';
		size = 0;
		for(chanl = tmp->joinhead;chanl;chanl=chanl->next)
		{

			snprintf(b, 205, "%s%s%s ", chanl->is_voice ? "+" : "", chanl->is_op ? "@" : "", chanl->channel);
			size += strlen(b);
			if(size >= 450) /* le dernier fait depasser le buffer */
			{
				strcat(chans, " ...\0");
				csntc(nick, "%s%s", !first ? " Il est sur: " : "", chans);
				strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
				first = 1;
				size = strlen(b);
			}
			else strcat(chans, b);
		}
		if(chans[0] == '\0') strcpy(chans, "Aucun salon");

		csntc(nick, "%s%s", !first ? " Il est sur: " : "", chans);
	}
	if(tmp->user)
	{
		csntc(nick, " %s est logu sous l'username \2%s\2%s", user, tmp->user->nick,\
		(tmp->user->level > 1) ? " (\2Admin\2)" : "");
		if(auth)
		{
			chans[0] = '\0';
			size = first = 0;

			for(acces = tmp->user->accesshead;acces;acces=acces->next)
			{
				snprintf(b, 205, "%s ", acces->chan);
				size += strlen(b);
				if(size >= 450)
				{
					strcat(chans, " ...\0");
					csntc(nick, "%s%s", !first ? " Il a accs : " : "", chans);
					strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
					first = 1;
					size = strlen(b);
				}
				else strcat(chans, b);
			}

			if(chans[0] != '\0') csntc(nick, "%s%s", !first ? " Il a accs : " : "", chans);
			else csntc(nick, " Il n'a aucun accs.");
		}
	}
	else
	{
		if((ux = getuserinfo(user))) csntc(nick, " %s est un username enregistr. %s", \
		ux->nick, IsAnAdmin(ux) ? " (\2Admin\2)" : "");
	}

	csntc(nick, " Connect depuis %s sur \2%s", duration(time(NULL) - tmp->ttmco), tmp->server);
	return;
}

void admin_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *user = parv[2];
	const char *arg = parv[1];
	anUser *u = NULL;
	anAccess *a, *a2;
	aNick *n;
	aWaitAccess *wa;

	if(!strcasecmp(arg, "info"))
	{
		int mail,seen,date,auth,suspend,count,oubli,first,nopurge;
		int cur = 0, size, firstt = 0;
		long ttm = time(NULL);
		char tmp[75], b[205], chans[451];

		if(parv[2][0]=='-') user = "*";

		mail=getoption("-mail",parv,parc,2,0);
		seen=getoption("-seen",parv,parc,2,1);
		date=getoption("-date",parv,parc,2,1);
		count=getoption("-count",parv,parc,2,1);
		auth=getoption("-auth",parv,parc,2,-1);
		suspend=getoption("-suspend",parv,parc,2,-1);
		oubli=getoption("-oubli",parv,parc,2,-1);
		first=getoption("-first",parv,parc,2,-1);
		nopurge=getoption("-nopurge",parv,parc,2,-1);

		if(strlen(user)>40) return;

		for(u=userhead;u;u=u->next)
		{
			if((!mail || !match(parv[mail],u->mail))
			&& (!seen || (ttm - u->lastseend) <= seen)
			&& (!date || ttm >= u->lastseend)
			&& (!auth || (auth && u->n) || (!auth && !u->n))
			&& (!suspend || u->suspendu > 0)
			&& (!oubli || UOubli(u))
			&& (!first || UFirst(u))
			&& (!nopurge || UNopurge(u))
			&& (!match(user,u->nick)))
			{
				cur++;
				if(!count || cur <= count)
				{
					csntc(nick, "Infos sur l'username \2%s\2 :", u->nick);
					csntc(nick, " Mail: %s", u->mail);

					if(UFirst(u)) csntc(nick, " En cours de validation, enregistrement il y a %s", duration(time(NULL) - u->lastseend));
					else csntc(nick, " Logu pour la dernire fois il y a %s", duration(time(NULL) - u->lastseend));
					if(UOubli(u)) csntc(nick, " A utilis la commande oubli");
					if(IsAnAdmin(u)) csntc(nick, " \2Accs Administrateur.\2 (\002%d\2)", u->level);

					chans[0] = '\0';
					size = 0;
					for(a = u->accesshead;a;a=a->next)
					{
						snprintf(b, 220, "%s (%d) ", a->chan, a->level);
						size += strlen(b);
						if(size >= 450) /* le dernier fait depasser le buffer */
						{
							strcat(chans, " ...\0");
							csntc(nick, "%s%s", !firstt ? " Il a accs : " : "", chans);
							strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
							firstt = 1;
							size = strlen(b);
						}
						else strcat(chans, b);
					}

					strcat(chans, "\0");
					if(chans[0] != '\0') csntc(nick, "%s%s", !firstt ? " Il a accs : " : "", chans);

					chans[0]='\0';
					for(wa=u->wahead;wa;wa=wa->next)
					{
						snprintf(b, 220, "%s (%d) ", wa->chan, wa->level);
						strncat(chans, b, 450);
					}
					strcat(chans, "\0");
					if(chans[0] != '\0' && (u->flag & U_POKACCESS)) csntc(nick, " Il a des propositions d'access pour: %s", chans);
					if(!(u->flag & U_POKACCESS)) csntc(nick, " Il %s systmatiquement les propositions d'access.", (u->flag & U_PACCEPT) ? "accepte" : "refuse");
					if((n = u->n)) csntc(nick, " %s%s est actuellement logu sous cet Username (%s@%s)",\
					GetPrefix(n), n->nick, n->ident, n->host);
					else csntc(nick, " Personne n'est actuellement logu sous cet username");
					//if(u->vote) csntc(nick, "Il a vot pour %s", vote[(u->vote-1)].prop);

					if(u->suspendu > 0) snprintf(tmp, 75, "depuis le %s", get_time(u->suspendu));
					else if(u->suspendu < 0) snprintf(tmp, 75, "Dj suspendu il y a %s", duration((time(NULL) - (-1 * u->suspendu))));
					else sprintf(tmp, "Jamais");

					csntc(nick, " Il %s suspendu (%s)", (u->suspendu > 0)? "est" : "n'est pas", tmp);
					csntc(nick, " Options: %s", GetUserOptions(u));

					if(!count || count>1) csntc(nick, "-");
				}
			}
		}

		if(cur)
		{
			if(count && count < cur) sprintf(tmp,"(%d listes)", count);
			else tmp[0]='\0';
			csntc(nick, "Un Total de %d entre%s trouve%s %s", cur, cur > 1 ? "s" : "", cur > 1 ? "s": "", tmp);
		}
		else csntc(nick, "Aucun Username correspondand  \002%s\002 trouv.", user);
		return;
	}

	if(!strcasecmp(arg, "match"))
	{
		char host[USERLEN + HOSTLEN], b[100];
		int i = 0, d = 0;
		struct timeval tv;
		long ticks;

		gettimeofday(&tv, NULL);
		ticks=tv.tv_usec;


		if(parc>2) d=atoi(parv[3]);

		csntc(nick, "Listing Nicks...");

		for(n = nickhead;n;n=n->next)
		{
			snprintf(host, (USERLEN + HOSTLEN), "%s@%s", n->ident, n->host);
			if(!match(user, host))
			{
				if(!d || (i < d)) csntc(nick, "Matching Nick: \2%s%s\2 -> %s", GetPrefix(n), n->nick, host);
				i++;
			}
		}

		if(d && (i > d)) sprintf(b, " (%d entres listes.)", d);
		else sprintf(b, " ");

		gettimeofday(&tv, NULL);
		csntc(nick, "Fin de la Recherche sur\2 %s\2 : %d matche%s trouv%s%s. (Effectue en %6.3f ms)"\
		, user, i, (i > 1) ? "s" : "", (i > 1) ? "s" : "", b,(float) (tv.tv_usec - ticks)/1000);
		return;
	}

	if(!strcasecmp(arg, "suspend"))
	{
		if(!strcasecmp(nick->user->nick, user))
		{
			csntc(nick, "Vous ne devriez pas vous suspendre.. (Utilisez la commande SUSPENDME)");
			return;
		}
		if(!(u=getuserinfo(user)))
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}
		if(IsAnAdmin(u) && u->level >= nick->user->level)
		{
			csntc(nick, "Vous ne pouvez pas suspendre un Admin de niveau suprieur ou gal.");
			return;
		}
		u->suspendu = (u->suspendu > 0) ? (-1 * time(NULL)) : time(NULL);
		csntc(nick, "L'username \002%s\002 est bien %ssuspendu.", u->nick, (u->suspendu > 0) ? "" : "de");
		if((n = u->n))
		{
			n->user->n = (u->suspendu > 0) ? NULL : n;
			csntc(n, "Votre Username vient d'tre %ssuspendu par l'Admin %s.", (u->suspendu > 0) ? "" : "de", nick->nick);
		}
		write_anuser(u);
		return;
	}

	if(!strcasecmp(arg, "mail"))
	{
		if(parc < 3 || !strchr(parv[3], '@') || !IsValidMail(parv[3]))
		{
			csntc(nick, "Veuillez prciser un Mail valide.");
			return;
		}
		if(!(u = getuserinfo(user)))
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}
		strncpy(u->mail, parv[3], 150);
		csntc(nick, "Le mail de %s a t chang en \002%s", u->nick, parv[3]);
		write_anuser(u);
		return;
	}

	if(!strcasecmp(arg, "newpass"))
	{
		char p[15];
		if(parc < 3 || strlen(parv[3]) < 6)
		{
			csntc(nick, "Veuillez entrer un pass (Valide).");
			return;
		}
		if(!(u = getuserinfo(user)))
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}

		if(IsAnAdmin(u) && u->level >= nick->user->level && strcasecmp(u->nick,nick->user->nick))
		{
			csntc(nick, "Vous ne pouvez pas changer le pass d'un Admin de niveau suprieur ou gal.");
			return;
		}

		strncpy(p,parv[3],15);
		strcpy(u->passwd, mkpass(p, "lala"));
		csntc(nick, "Le mot de pass de \2%s\2 a bien t chang.", user);
		write_anuser(u);
		return;
	}

	if(!strcasecmp(arg, "newnick"))
	{
		char *newusr = NULL;
		anUser *utmp;
		int found = 0;
		if(parc < 3 || strlen(parv[3]) > NICKLEN)
		{
			csntc(nick, "Veuillez entrer un username (Valide).");
			return;
		}
		if(!IsValidNick(parv[3]))
		{
			csntc(nick, "UserName invalide.");
			return;
		}
		newusr = parv[3];
		for(utmp=userhead;utmp;utmp=utmp->next)
		{
			if(!strcasecmp(utmp->nick, newusr))
			{
				csntc(nick, "%s est un username dj utilis", newusr);
				return;
			}
			if(!strcasecmp(utmp->nick, user))
			{
				found = 1;
				u = utmp;
			}
		}
		if(!found)
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}

		if(IsAnAdmin(u) && u->level >= nick->user->level && strcasecmp(u->nick,nick->user->nick))
		{
			csntc(nick, "Vous ne pouvez pas changer l'username d'un Admin de niveau suprieur ou gal.");
			return;
		}

		strcpy(u->nick, newusr);
		if(u->n) cs_account(u->n, newusr);
		csntc(nick, "L'username de %s a t chang en %s.", user, newusr);
		write_anuser(u);
		return;
	}

	if(!strcasecmp(arg, "del"))
	{
		if(!strcasecmp(nick->user->nick, user))
		{
			csntc(nick, "Vous ne devriez pas vous deluser.. (Utilisez la commande DROP)");
			return;
		}
		if(!(u = getuserinfo(user)))
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}
		if(IsAnAdmin(u) && u->level >= nick->user->level)
		{
			csntc(nick, "Vous ne pouvez supprimer un Username d'Admin de niveau suprieur ou gal.");
			return;
		}
		if((n = u->n))
		{
			char raison[200];
			if(parc > 2) parv2msgn(parc, parv, 3, raison, 200);
			else strcpy(raison, "");

			cs_account(n, NULL);
			csntc(n, "Votre Username vient d'tre supprim par l'Admin %s %s", nick->nick, raison);
			n->user->n = NULL;
			n->user = NULL;
		}

		csntc(nick, "L'username %s a bien t supprim.", u->nick);

		for(a=u->accesshead;a;a=a2)
		{
			a2=a->next;
			if(a->level == 500)
			{
				csntc(nick, "Le salon %s a t dsenregistr (%s en tait l'owner)", a->chan, u->nick);
				cspart(a->chan, "Salon dsenregistr par %s -\002 Suppression de l'username de l'owner", nick->nick);
				cswallops("Le salon %s a t dsenregistr par %s -\002 Suppression de l'username de l'owner",a->chan, nick->nick);
				putlog(LOG_CHANS, "CHAN DEL %s par %s@%s (%s)\n", a->chan, nick->nick, nick->user->nick, "USER DEL de l'owner");

				del_chan(a->chan);
			}
		}
		del_regnick(u);
		write_userlist();
		return;
	}

	if(!strcasecmp(arg, "stats"))
	{
		int mem,cmds,traffic,all;
		mem=getoption("-mem",parv,parc,2,-1);
		cmds=getoption("-cmds",parv,parc,2,0);
		traffic=getoption("-traffic",parv,parc,2,-1);
		all=getoption("-all",parv,parc,2,-1);

		if(mem || all)
		{
			int mem = 0, usr = 0, chs = 0, usra = 0, ni=0;
			aChan *ch;
			aBan *ban;
			aJoin *j;
			struct badnicks *bn;
			struct badchans *bc;
			struct ignore *ig;
			for(n=nickhead;n;n = n->next)
			{
				ni++;
				mem += sizeof(struct nickinfo);
				for(j=n->joinhead;j;j = j->next) mem += sizeof(struct joininfo);
			}
			for(u=userhead;u;u = u->next)
			{
				mem += sizeof(struct userinfo);
				usr++;
				if(u->n) usra++;
				for(a=u->accesshead;a;a=a->next) mem += sizeof(struct access);
			}
			ch = chanhead;
			while(ch)
			{
				mem += sizeof(struct chaninfo);
				chs++;
				for(ban=ch->banhead;ban;ban = ban->next) mem += sizeof(struct baninfo);
				ch=ch->next;
			}
			for(bn=badnhead;bn;bn = bn->next) mem += sizeof(struct badnicks);
			for(bc=badchead;bc;bc = bc->next) mem += sizeof(struct badchans);
			for(ig=ignorehead;ig;ig=ig->next) mem += sizeof(struct ignore);
			mem += sizeof(struct robot);
			mem += sizeof(struct bots);
			mem += sizeof(struct Link);
			csntc(nick, "Memoire Utilise pour les Users/Chans: %10.3f KB", mem / 1024.0);
			csntc(nick, "Il y a %d Usernames enregistrs et %d Chans.", usr, chs);
			csntc(nick, "%d Chatteurs connects, dont %4.1f %% actuellement logus.", ni, (usra / (float) ni) * 100);
		}
		if(cmds || all)
		{
			int x;

			for(x=0;cs_cmds[x].cmd[0]!='\0';x++)
			{
				if(!match(parv[cmds],cs_cmds[x].cmd) && cs_cmds[x].cmd[0]!='\1')
				csntc(nick, "- %s (\002%d\002)", cs_cmds[x].cmd, cs_cmds[x].used);
			}
		}
		if(traffic || all)
		{
			float up,down;
			int mbu=0,mbd=0;
			up=dataS/1024.0;
			down=dataQ/1024.0;
			if(up>=1024)
			{
				up=up/1024.0;
				mbu=1;
			}
			if(down>=1024)
			{
				down=down/1024.0;
				mbd=1;
			}
			csntc(nick, "Traffic: Up: \2%10.3f %s\2 Down: \2%10.3f %s\2", up, mbu ? "MB":"KB", down, mbd ? "MB":"KB");
		}
  		/*if(!strcasecmp(user, "users")) CPU/Ram pb
		{
			struct timeval tv;
			int tuser = 0,th=0;
			char *host[500], *l, *o = NULL;
			long ticks;
			gettimeofday(&tv, NULL);
			ticks=tv.tv_usec;
			host[0] = NULL;
			n = nickhead;
			while(n)
			{
				tuser++;
				if(!istk(host,n->host))
				{
					if(strchr((l=getuserbyhost(n->host)), ' '))
					{
						if(o!=l && o) free(o);
						o=l;
						csntc(nick, "clones sur \002%s\002 : %s", n->host, l);
						host[th++] = n->host;
					}
				}
				n=n->next;
			}
			if(o) free(o);
			gettimeofday(&tv, NULL);
			csntc(nick, "Il y a \002%d\002 Utilisateurs sur les serveurs.
			(\002%d\002 hosts prsentent des clones) Effectu en : \002%6.3f\002 ms",tuser,th,(float) (tv.tv_usec - ticks)/1000);;
		}*/
		if(!all && !mem && !traffic && !cmds) csntc(nick, "Option de stats non valide");
		return;
	}

	if(!strcasecmp(arg,"list"))
	{
		DIR *dp;
		struct dirent *ep;
		anUser *t;
		aChan *chan;
		char p[200], path[120];
		int got = 0, stat = 0;
		int purge=getoption("-purge",parv,parc,2,-1);
		struct timeval tv;
		long ticks;

		gettimeofday(&tv, NULL);
		ticks=tv.tv_usec;

		if(!strcasecmp(parv[2],"user"))
		{
			if((dp=opendir("database/usr/")))
			{
				while((ep = readdir(dp)))
				{
					if(ep->d_name[0]!='.')
					{
						got=0;
						for(t=userhead;t;t=t->next)
						{
							conv_char(t->nick, p);
							if(!strcasecmp(p, ep->d_name)) { got=1; break; }
						}
						if(!got)
						{
							stat++;
							if(purge)
							{
								snprintf(path,120,"database/usr/%s", ep->d_name);
								remove(path);
							}
							csntc(nick, "Fichier User orphelin:\2 %s", ep->d_name);

						}
					}
				}
				closedir(dp);
			}
			else csntc(nick,"Impossible d'acceder  la database.");
		}
		if(!strcasecmp(parv[2],"chan"))
		{
			if((dp=opendir("database/chans/")))
			{
				while((ep = readdir(dp)))
				{
					if(ep->d_name[0]!='.')
					{
						got=0;
						for(chan=chanhead;chan;chan=chan->next)
						{
							conv_char(chan->chan, p);
							if(!strcasecmp(p, ep->d_name)) { got=1; break; }
						}
						if(!got)
						{
							stat++;
							if(purge)
							{
								snprintf(path,120,"database/chans/%s", ep->d_name);
								remove(path);
							}
							csntc(nick, "Fichier Chan orphelin: \2%s", ep->d_name);

						}
					}
				}
				closedir(dp);
			}
			else csntc(nick,"Impossible d'accder  la database.");
		}
		gettimeofday(&tv, NULL);
		csntc(nick, "%d fichiers %s en %6.3f ms.", stat, purge ? "purgs" : "lists", (float) (tv.tv_usec - ticks) / 1000);
		return;
	}
	if(!strcasecmp(arg, "nopurge"))
	{
		if(!(u = getuserinfo(user)))
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}
		if(parc < 3)
		{
			if(UNopurge(u)) DelUNopurge(u);
			else SetUNopurge(u);
		}
		else
		{
			if(!strcasecmp(parv[1], "ON")) SetUNopurge(u);
			else if(!strcasecmp(parv[1], "OFF")) DelUNopurge(u);
			else
			{
				csntc(nick, "La valeur doit tre ON ou OFF");
				return;
			}
		}
		csntc(nick, "Le NOPURGE de %s est %sactif", u->nick, UNopurge(u) ? "" : "in");
		write_anuser(u);
		return;
	}
	if(!strcasecmp(arg, "checkpass"))
	{
		if(!(u = getuserinfo(user)))
		{
			csntc(nick, NOSUCHUSER, user);
			return;
		}

		if(parc < 3)
		{
			csntc(nick, "Syntaxe: USER CHECKPASS <username> <pass>");
			return;
		}

		if(!checkpass(parv[3], u))
		{
			csntc(nick, "Le mot de passe est incorrect !", u->nick);
			return;
		}

		csntc(nick, "Le mot de passe est correct !", u->nick);
		return;
	}

	csntc(nick, "%s n'est pas une option valide.", arg);
	return;
}
