/* src/chaninfo.c - Lire les informations  propos d'un salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: chaninfo.c,v 1.10 2003/03/08 17:12:34 romexzf Exp $");

/*
 * chaninfo
 *
 * parv[1] = #salon
 */

void chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
  aLink *lp;
  char options[300], tmp[(NICKLEN + 15)], mask[20], buf[400];

  options[0] = '\0';

  for(lp=chaninfo->access;lp && lp->value.a->level != 500;lp=lp->next);
  csntc(nick, "------------------[ \0032\002%s\002\0036 > Informations\003         ]------------------", parv[1]);
  csntc(nick, "\002Fondateur     :\002 %s", lp ? lp->value.a->user->nick : "Aucun");
  csntc(nick, "\002Description   :\002 %s", chaninfo->description);
  if(IsAnAdmin(nick->user) || !strchr(chaninfo->defmodes, 'k'))
    csntc(nick, "\2Defmodes      :\2 %s", chaninfo->defmodes);
  else
  {
	  char *tmp2=NULL;
	  tmp2=chaninfo->defmodes;
	  strtok(tmp2, " ");
	  csntc(nick, "\2Defmodes      :\2 %s", tmp2);
  }

  csntc(nick, "\2Deftopic      :\2 %s", chaninfo->deftopic);
  if(IsAnAdmin(nick->user)) csntc(nick, "\2Motd          :\002 %s", chaninfo->motd);
  if(IsAnAdmin(nick->user) && CWantUnreg(chaninfo)) csntc(nick, "\2Salon en procdure d'Unreg\2");
  csntc(nick, "\2Url du salon  :\2 %s", chaninfo->url);

  if(CLockTopic(chaninfo)) strcat(options, " locktopic");
  if(CNoOps(chaninfo)) strcat(options, " noops");
  if(CNoBans(chaninfo)) strcat(options, " nobans");
  if(CStrictOp(chaninfo)) strcat(options, " strictop");
  if(CSetWelcome(chaninfo)) strncat(options, " welcome", 300);
  if(CAutoInvite(chaninfo)) strncat(options, " autoinvite", 300);
  if(chaninfo->suspend[0] != '\0') strncat(options, " suspendu", 300);
  strcat(options, "\0");

  csntc(nick, "\002Options       :\002%s", options[0] != '\0' ? options : " Aucunes");
  csntc(nick, "\002Banlevel      :\002 %d", chaninfo->banlevel);
  switch(chaninfo->bantype)
  {
	  case 1: strcpy(mask, "*!*ident@*.host"); break;
	  case 2: strcpy(mask, "*!*ident@*"); break;
	  case 3: strcpy(mask, "*nick*!*@*"); break;
	  case 4: strcpy(mask, "*!*@host"); break;
	  default: strcpy(mask, "<aucun>");
  }

  csntc(nick, "\002Bantype       :\002 %s", mask);
  if(CSetWelcome(chaninfo)) csntc(nick, "\002Welcome       :\002 %s", chaninfo->welcome);
  if(chaninfo->suspend[0] != '\0') csntc(nick, "\002Suspendu      :\002 %s", chaninfo->suspend);
  csntc(nick, "\002Topic actuel  :\002 %s", chaninfo->topic);
  csntc(nick, "\002Modes actuels :\002 %s", chaninfo->modes);
  if(chaninfo->key[0] != '\0' && IsAnAdmin(nick->user)) csntc(nick, "\2Clef de salon :\2 %s", chaninfo->key);
  if(IsAnAdmin(nick->user))
  {
	  int first=1, size = 0;
	  buf[0]='\0';
	  for(lp=chaninfo->members;lp;lp=lp->next)
	  {
		  snprintf(tmp, (NICKLEN + 15), " %s%s", GetChanPrefix(lp->value.j->nick, lp->value.j), lp->value.j->nick->nick);
		  size += strlen(tmp);
		  if(size >= 400)
		  {
			  strcat(buf, "...\0");
			  if(first) csntc(nick, "\2Users du salon:\002%s", buf);
			  else csntc(nick, "              :%s", buf);
			  first = 0;
			  strcpy(buf, tmp);
			  size = strlen(tmp);
		  }
		  else strcat(buf, tmp);
	}
	strcat(buf, "\0");
	if(first && buf[0]!='\0') csntc(nick, "\2Users du salon:\002%s", buf);
	else if(buf[0]!='\0') csntc(nick, "              :%s", buf);
  }
  csntc(nick, "-");
  csntc(nick, "Utilisez la commande BANLIST pour voir les bans, et la commande ACCESS pour la liste des accs au salon.");
  return;
}
