/* src/fichiers.c - Lecture/criture des donnes
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <time.h>
#include "main.h"

CVSINFO("$Id: fichiers.c,v 1.12 2003/03/08 21:29:52 romexzf Exp $");

struct aConfPara conftab[] = {
 { "SERVER", 0, "SERVER <nom du serveur>"},
 { "IP", 0, "IP <ip  laquelle le robot va se connecter>"},
 { "PORT", 0, "PORT <port server du hub>"},
 { "PASS", 0, "PASS <mot de passe de la C line sur le hub>"},
 { "NUMERIC", 0, "NUMERIC <un chiffre entre 0 et 63"},
 { "CS:NICK", 0, "CS:NICK <pseudo du robot>"},
 { "CS:IDENT", 0, "CS:IDENT <ident du robot>"},
 { "CS:HOST", 0, "CS:HOST <Hostname du robot"},
 { "CS:NAME", 0, "CS:NAME <nom du robot"},
 { "WS:NICK", 0, "WS:NICK <pseudo du robot de bienvenue>"},
 { "WS:IDENT", 0, "WS:IDENT <ident du robot de bienvenue>"},
 { "WS:HOST", 0, "WS:HOST <Hostname du robot de bienvenue>"},
 { "WS:NAME", 0, "WS:NAME <nom du robot de bienvenue>"},
 { "CHAN", 0, "CHAN <salon o les robots disent les commandes tapes"},
 { "QUIT_MSG", 0, "QUIT_MSG <message de QUIT>"},
 { "MODES", 0, "MODES <modes des robots>"},
 { "NAME", 0, "NAME <nom du serveur>"},
 { "PASDEPERM", 0, "PASDEPERM <message envoy  un user qui utilise une commande  laquelle il n'a pas access>"},
 { "CHANHELP", 0, "CHANHELP <salon automatiquement enregistr lors du HELLO (salon d'aide)>"},
 { "CHAR", 0, "CHAR <caractre a taper avant une commande dans un salon>"},
 { "KILLNICK", 0, "KILLNICK <Interval qu'attend le robot avant de kill les users non identifis sur les pseudos en setkill ON>"},
 { "CHANGE_NICK", 0, "CHANGE_NICK <1/0> (active/desactive le changement de nick au lieu d'un KILL lors de la prise d'un badnick)"},
 { "MAXLASTSEEN", 0, "MAXLASTSEEN <lastseen en secondes maximal avant la suppression de l'username>"},
 { "ADMINEXEMPT", 0, "ADMINEXEMPT <1/0> (active/desactive l'exeption des admins pour la protection anti flood)"},
 { "KILLFORFLOOD", 0, "KILLFORFLOOD <1/0> (si actif, les users qui flood seront kill)"},
 { "IGNORETIME", 0, "IGNORETIME <nombre de secondes qu'ignore le robot>"},
 { "NETWORK", 0, "NETWORK <nom du rseau>"},
 { "MAILPROG", 0, "MAILPROG <chemin vers le programme SENDMAIL>"},
 { "HOST_HIDING", 0, "HOST_HIDING <1/0> (si actif, lors d'une identification l'host des users sera <login>.<HIDDEN_HOST> (HIDDEN_HOST est paramtrable)"},
 { "HIDDEN_HOST", 0, "HIDDEN_HOST <fin de l'host lors du changement de l'host en <login>.<HIDDEN_HOST>"},
 { "XMODE", 0, "XMODE <1/0> (active/desactive le mode +x. Si il est activ, le changement d'host du au HOST_HIDING ne se fera pas lors de l'identification mais lors de la mise du +x)"},
 { "HIDECODER", 0, "HIDECODER <1/0> (active/desactive le masquage des admin level 4 de la commande ADMIN)"},
 { NULL, 0}
};

int kill_interval = 25;
int ConfFlag;
int ignoretime=600;
int maxlastseen=1000000;
char *quit_msg = NULL;
char pasdeperm[200];
char *network = NULL;
char *mailprog = NULL;
char HIDDEN_HOST[HOSTLEN];

extern struct badchans *badchead;
extern struct badnicks *badnhead;
extern struct baninfo *banhead;

extern struct cs_commands cs_cmds[];

int load_config(char *filename)
{
  char *ptr;
  FILE *cfg;
  char buf[512];
  char param[512];
  char value[512];
  int i=0,n,f,a;

  if (!( cfg = fopen(filename,"r")))
  {
    perror("Impossible d'ouvrir le fichier de configuration");
    return -1;
  }

  while (fgets(buf, 512, cfg))
  {
    i++;
    n=strlen(buf);
    if (buf[n-1] == '\n') buf[n-1] = '\0';
    n=strlen(buf);
    if (buf[n-1] == '\r') buf[n-1] = '\0'; /* Windoze-editor friendly ;p */

    ptr=strchr(buf,'*');
    if (ptr) *ptr = '\0';

    f=0;
    for (n=0; n<strlen(buf); n++)
    {
      if ((buf[n] != ' ') && (buf[n] != '\t'))
      {
        f=1;
        break;
      }
    }

    if(!f) continue; /* blank line are ignored */
    if(sscanf(buf, "%s %s", param, value)!=2)
    {
		printf("Fichier de configuration: Erreur ligne %u\n", i);
		fclose(cfg);
		return -1;
    }
    sscanf(buf, "%s %n", param, &a);
    strncpy(value, &buf[a], 512);

    if (!strcmp(param,"SERVER"))
    {
		if(!strchr(value, '.')) {
			printf("Le Serveur d'Uplink semble invalide. (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[0].flag = 1;
      strncpy(bot.server, value, 150);
      continue;
    }
    if (!strcmp(param,"IP"))
    {
		if(strlen(value) > 16 || !is_ip(value)) {
			printf("L'IP %s semble invalide. (ligne %d)\n", value, i);
			fclose(cfg);
			return -1;
		}
		conftab[1].flag = 1;
		strncpy(bot.ip, value, 30);
		continue;
    }
    if (!strcmp(param,"PORT"))
    {
		if(!is_num(value) || atoi(value) <= 0 || atoi(value) > 65535) {
			printf("Port de link invalide: (ligne %d)\n", i);
			fclose(cfg);
			return -1;
		}
		conftab[2].flag = 1;
		bot.port = atoi(value);
		continue;
    }
    if (!strcmp(param,"PASS"))
    {
		conftab[3].flag = 1;
		strncpy(bot.pass, value, 150);
		continue;
    }
    if (!strcmp(param,"NUMERIC"))
    {
		if(!is_num(value) || atoi(value) > 4096)
		{
			printf("Numeric non valide %s (Devrait etre entre 0 et 4096) (ligne %d)\n",value,i);
			fclose(cfg);
			return -1;
		}
		conftab[4].flag = 1;
		bot.num = atoi(value);
		continue;
    }
    if (!strcmp(param,"CS:NICK"))
    {
		conftab[5].flag = 1;
		strncpy(cs.nick, value, NICKLEN);
		if(strlen(value) > (NICKLEN-1)) printf("Nick du CS trop long, tronqu en %s (ligne %d)\n", cs.nick, i);
		continue;
    }
    if (!strcmp(param,"CS:IDENT"))
    {
		conftab[6].flag = 1;
		strncpy(cs.ident, value, USERLEN);
		if(strlen(value) > (USERLEN-1)) printf("Ident du CS trop longue, tronque en %s (ligne %d)\n", cs.ident, i);
		continue;
    }
    if (!strcmp(param,"CS:HOST"))
    {
		conftab[7].flag = 1;
		strncpy(cs.host, value, HOSTLEN);
		if(strlen(value) > (HOSTLEN-1)) printf("Host du CS trop longue, tronque en %s (ligne %d)\n", cs.host, i);
		continue;
    }
    if (!strcmp(param,"CS:NAME"))
    {
		conftab[8].flag = 1;
		strncpy(cs.name, value, REALEN);
		if(strlen(value) > (REALEN-1)) printf("RealName du CS trop long, tronqu en %s (ligne %d)\n", cs.name, i);
		continue;
    }
    if (!strcmp(param,"WS:NICK"))
    {
		conftab[9].flag = 1;
		strncpy(ws.nick, value, NICKLEN);
		if(strlen(value) > (NICKLEN-1)) printf("Nick du Welcome trop long, tronqu en %s (ligne %d)\n", ws.nick, i);
		continue;
	}
    if (!strcmp(param,"WS:IDENT"))
    {
		conftab[10].flag = 1;
		strncpy(ws.ident, value, USERLEN);
		if(strlen(value) > (USERLEN-1)) printf("Ident du Welcome trop longue, tronque en %s (ligne %d)\n", ws.ident, i);
		continue;
    }
    if (!strcmp(param,"WS:HOST"))
    {
		conftab[11].flag = 1;
		strncpy(ws.host, value, HOSTLEN);
		if(strlen(value) > (HOSTLEN-1)) printf("Host du Welcome trop longue, tronque en %s (ligne %d)\n", ws.host, i);
		continue;
    }
    if (!strcmp(param,"WS:NAME"))
    {
		conftab[12].flag = 1;
		strncpy(ws.name, value, REALEN);
		if(strlen(value) > (REALEN-1)) printf("RealName du Welcome trop long, tronqu en %s (ligne %d)\n", ws.name, i);
		continue;
    }
    if (!strcmp(param,"CHAN"))
    {
		if(value[0] != '#')
		{
			printf("Format de salon invalide '%c' (ligne %d)\n",value[0],i);
			fclose(cfg);
			return -1;
		}
		conftab[13].flag = 1;
		strncpy(cs.chan,value,200);
		continue;
    }
    if (!strcmp(param,"QUIT_MSG"))
    {
		conftab[14].flag = 1;
		if(!quit_msg) quit_msg = (char *) malloc(100);
		strncpy(quit_msg, value, 100);
		continue;
    }
    if (!strcmp(param,"MODES"))
    {
		conftab[15].flag = 1;
		strncpy(cs.mode, value, 10);
		continue;
	}
    if (!strcmp(param,"NAME"))
    {
		conftab[16].flag = 1;
		strncpy(bot.name, value, 100);
		continue;
    }
    if (!strcmp(param,"PASDEPERM"))
    {
		conftab[17].flag = 1;
		strncpy(pasdeperm, value, 200);
		if(strlen(value) > 200) printf("Message d'Accs refus trop long, tronqu en %s (ligne %d)\n",pasdeperm,i);
		continue;
    }
    if (!strcmp(param,"CHANHELP"))
    {
		if(value[0] != '#')
		{
			printf("Format de salon invalide '%c' (ligne %d)\n",value[0],i);
			fclose(cfg);
			return -1;
		}
		conftab[18].flag = 1;
		strncpy(bot.chan, value, 200);
		continue;
    }
    if (!strcmp(param,"CHAR"))
    {
		conftab[19].flag = 1;
		bot.cara = *value;
		continue;
    }
    if (!strcmp(param,"KILLNICK"))
    {
		if(!is_num(value))
		{
			printf("Le temps d'attente pour les KILLs doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
		conftab[20].flag = 1;
		kill_interval = atoi(value);
		continue;
    }
    if (!strcmp(param,"CHANGE_NICK"))
    {
		conftab[21].flag = 1;
		if(atoi(value)) ConfFlag |= CF_CHANGENICK;
		else ConfFlag &= ~CF_CHANGENICK;
		continue;
    }
    if (!strcmp(param,"MAXLASTSEEN"))
    {
		if(!is_num(value))
		{
			printf("Le temps maximum avant la purge doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
		conftab[22].flag = 1;
		maxlastseen = atoi(value);
		continue;
    }
    if (!strcmp(param,"ADMINEXEMPT"))
    {
		if(!is_num(value))
		{
			printf("Admin Exempt pour le flood doit tre  0 ou 1 (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
		conftab[23].flag = 1;
		if(atoi(value)) ConfFlag |= CF_ADMINEXEMPT;
		else ConfFlag &= ~CF_ADMINEXEMPT;
		continue;
    }
    if (!strcmp(param,"KILLFORFLOOD"))
    {
		if(!is_num(value))
		{
			printf("Le Kill pour flood doit tre  1 ou 0 (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
		conftab[24].flag = 1;
		if(atoi(value)) ConfFlag |= CF_KILLFORFLOOD;
		else ConfFlag &= ~CF_KILLFORFLOOD;
		continue;
    }
    if (!strcmp(param,"IGNORETIME"))
    {
		if(!is_num(value))
		{
			printf("Le temps d'ignore doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
		conftab[25].flag = 1;
		ignoretime = atoi(value);
		continue;
    }
    if (!strcmp(param,"NETWORK"))
    {
    	if(strchr(value, ' '))
    	{
			printf("Le nom du rseau doit tre compos d'un seul mot (ex: Inter-System.net) (ligne %d)\n", i);
			fclose(cfg);
			return -1;
		}
		if(!network) network = (char *) malloc(80);
    	conftab[26].flag = 1;
    	strncpy(network, value, 80);
    	continue;
    }
    if (!strcmp(param,"MAILPROG"))
    {
    	conftab[27].flag = 1;
    	if(!mailprog) mailprog = (char *) malloc(80);
    	strncpy(mailprog, value, 80);
    	continue;
    }
    if (!strcmp(param,"HOST_HIDING"))
    {
    	conftab[28].flag = 1;
    	if(atoi(value)) ConfFlag |= CF_HOSTHIDING;
    	else ConfFlag &= ~CF_HOSTHIDING;
    	continue;
    }
    if (!strcmp(param,"HIDDEN_HOST"))
    {
    	conftab[29].flag = 1;
    	strncpy(HIDDEN_HOST, value, HOSTLEN);
    	continue;
    }
    if (!strcmp(param,"XMODE"))
    {
    	conftab[30].flag = 1;
    	if(atoi(value)) ConfFlag |= CF_XMODE;
    	else ConfFlag &= ~CF_XMODE;
    	continue;
    }
    if (!strcmp(param,"HIDECODER"))
    {
    	conftab[31].flag = 1;
    	if(atoi(value)) ConfFlag |= CF_HIDE_ADML4;
    	else ConfFlag &= ~CF_HIDE_ADML4;
    	continue;
    }
    printf("Fichier de configuration: Erreur  la ligne %u\n", i);
    fclose(cfg);
    return -1;
  }
  for (i=0; conftab[i].name; i++)
  {
    if (!conftab[i].flag)
    {
		printf("Paramtre de configuration introuvable: %s\n", conftab[i].name);
		printf("-> %s\n", conftab[i].syntax);
		fclose(cfg);
		return -1;
    }
  }
  fclose(cfg);
  return 0;
}

void load_users()
{
	FILE *fp, *fp1;
	char buff[100], buff1[500], *user = NULL, nuser[50], *mail =NULL, *suspendu = NULL;
	char *nick = NULL, *pass = NULL, *lastseend = "0", *level = NULL, *field = NULL;
	char
#ifdef USE_MEMOSERV
*de = NULL, *date = NULL,
#endif
*tmp = NULL, *chan = NULL, *voted = NULL;
	int adm=0, fileversion = 1, flag, flaga;
	struct userinfo *u=NULL;

	if(!(fp = fopen(USERS_FILE, "r")))
	{
		premiere = 1;
		return;
	}
	while(fgets(buff, 100, fp))
	{
		strip_newline(buff);
		user = strtok(buff, " ");
		nuser[0] = '\0';
		conv_char(user, nuser);
		strlwr(nuser);
		sprintf(buff1, "database/usr/%s", nuser);
		if(!(fp1 = fopen(buff1, "r"))) continue;
		buff1[0] = '\0';

		while(fgets(buff1, 500, fp1))
		{
			flag=0;
			strip_newline(buff1);
			if((field = strchr(buff1, ' '))) *field++ = '\0';
			if(!strcmp(buff1, "VERSION") && field) fileversion = atoi(field);
			if(!strcmp(buff1, "NICK") && field)
			{
				nick = strtok(field, " ");
				pass = strtok(NULL, " ");
				level = strtok(NULL, " ");
				if(fileversion >= 12)
				{
					suspendu = strtok(NULL, " ");
					lastseend = strtok(NULL, " ");
					flag = atoi(strtok(NULL, " "));
					voted = strtok(NULL, " ");
					mail = strtok(NULL, " ");
				}
				else
				{
					char *setkill=NULL, *mynick=NULL, *want_x=NULL, *nopurge=NULL, *oubli=NULL, *first=NULL, *accesspolicy=NULL;
					setkill = strtok(NULL, " ");
					lastseend = strtok(NULL, " ");
					suspendu = strtok(NULL, " ");
					if(fileversion >= 3) mynick = strtok(NULL, " ");
					if(fileversion >= 4) voted = strtok(NULL, " ");
					if(fileversion >= 5) want_x = strtok(NULL, " ");
					if(fileversion >= 6) nopurge = strtok(NULL, " ");
					if(fileversion >= 9) oubli = strtok(NULL, " ");
					if(fileversion >= 10) first = strtok(NULL, " ");
					if(fileversion >= 11) accesspolicy = strtok(NULL, " ");
					mail = strtok(NULL, " ");

					if(setkill && is_num(setkill) && atoi(setkill)) flag |= U_KILL;
					if(mynick && is_num(mynick) && atoi(mynick)) flag |= U_PROTECT;
					if(want_x && is_num(want_x) && atoi(want_x)) flag |= U_WANTX;
					if(oubli && is_num(oubli) && atoi(oubli)) flag |= U_OUBLI;
					if(first && is_num(first) && atoi(first)) flag |= U_FIRST;
					if(nopurge && is_num(nopurge) && atoi(nopurge)) flag |= U_NOPURGE;

					if(accesspolicy && is_num(accesspolicy))
					{
						if(atoi(accesspolicy) == 1) flag |= U_POKACCESS;
						else if(atoi(accesspolicy) == 0) flag |= U_PREJECT;
						else if(atoi(accesspolicy) == 2) flag |= U_PACCEPT;
					}
				}

				u=add_regnick(nick, pass, atoi(lastseend), atoi(level), flag, atoi(suspendu), mail, (voted && is_num(voted)) ? atoi(voted) : 0);

				if(is_num(level) && atoi(level) > 1) adm = 1;
			}

#ifdef USE_MEMOSERV
			if(!strcmp(buff1, "MEMO") && field)
			{
				tmp = strchr(field, ':');
				if (*tmp == ':') tmp++;
				de = strtok(field, " ");
				date = strtok(NULL, " ");
				add_memo(u, de, atoi(date), tmp);
			}
#endif

			if(!strcmp(buff1, "ACCESS") && field)
			{
				flaga = 0;
				tmp = strchr(field, ':');
				if (*tmp == ':') tmp++;
				chan = strtok(field, " ");
				level = strtok(NULL, " ");
				if(fileversion >= 13) flaga = atoi(strtok(NULL, " "));
				else
				{
					char *autoop = NULL, *autovoice = NULL, *protect = NULL;
					autoop = strtok(NULL, " ");
					autovoice = strtok(NULL, " ");
					protect = strtok(NULL, " ");
					suspendu = strtok(NULL, " ");
					if(autoop && atoi(autoop)) flaga |= A_OP;
					if(autovoice && atoi(autovoice)) flaga |= A_VOICE;
					if(suspendu && atoi(suspendu)) flaga |= A_SUSPEND;
					if(protect && atoi(protect)) flaga |= A_PROTECT;
				}
				if(fileversion >= 1)
				{
					lastseend = strtok(NULL, " ");
					if(!is_num(lastseend)) lastseend = "0";
				}

				add_access(u, chan, atoi(level), flaga, tmp, atol(lastseend));
			}
			if(fileversion >= 2 && !strcmp(buff1, "WAITACCESS") && field)
			{
				chan = strtok(field, " ");
				level = strtok(NULL, " ");

				add_waitaccess(u, chan, atoi(level));
			}
			field[0] = '\0';
		}
		fclose(fp1);
	}
	fclose(fp);
	if(!adm) printf("Aucun Admin localis dans la Base de Donnes!!\n");
}

void write_userlist()
{
   FILE *fp;
   anUser *user;

   if(!(fp = fopen(USERS_FILE, "w"))) return;

   for(user=userhead;user;user=user->next) fprintf(fp, "%s\n", user->nick);

   fclose(fp);
   return;
}

void write_anuser(anUser *nick)
{
#ifdef USE_MEMOSERV
   struct memos *memo;
#endif
   anAccess *access;
   aWaitAccess *wa;
   FILE *fp1;
   char nuser[50], buff[100];

   nuser[0] = '\0';

   conv_char(nick->nick, nuser);
   snprintf(buff, 100, "database/usr/%s", nuser);
   strlwr(buff);
   if(!(fp1 = fopen(buff, "w"))) return;

	fprintf(fp1, "VERSION %d\n", USRS_VERSION);
#ifdef HAVE_VOTE
	fprintf(fp1, "NICK %s %s %d %d %d %d %d %s\n", nick->nick, nick->passwd, nick->level, nick->suspendu, nick->lastseend, nick->flag, nick->vote, nick->mail);
#else
	fprintf(fp1, "NICK %s %s %d %d %d %d %d %s\n", nick->nick, nick->passwd, nick->level, nick->suspendu, nick->lastseend, nick->flag, 0, nick->mail);
#endif
#ifdef USE_MEMOSERV

	for(memo = nick->memohead;memo;memo=memo->next) fprintf(fp1, "MEMO %s %d :%s\n", memo->de, memo->date, memo->message);
#endif

    for(access = nick->accesshead;access;access = access->next)
    	fprintf(fp1, "ACCESS %s %d %d %ld :%s\n", access->chan, access->level, access->flag, access->lastseen == 1 ? time(NULL) : access->lastseen, access->info);

    for(wa = nick->wahead;wa;wa = wa->next)
		fprintf(fp1, "WAITACCESS %s %d\n", wa->chan, wa->level);

    fclose(fp1);
    return;

}

void write_users()
{
   anUser *user;
   for(user = userhead;user;user=user->next) write_anuser(user);
}

void write_chanlist()
{
	FILE *fp;
	aChan *chan = chanhead;

	if(!(fp = fopen(CHANS_FILE, "w"))) return;

	for(;chan;chan=chan->next) fprintf(fp, "%s\n", chan->chan);

	fclose(fp);
	return;
}

void write_achan(aChan *chan)
{
	FILE *fchan;
	aBan *ban;
	char nchan[200], buff[230];

	nchan[0] = '\0';

	conv_char(chan->chan, nchan);
	snprintf(buff, 230, "database/chans/%s", nchan);
	strlwr(buff);
	if(!(fchan = fopen(buff, "w"))) return;

	fprintf(fchan, "MODES %s\nTOPIC %s\nDEFMODES %s\nDEFTOPIC %s\n", chan->modes, chan->topic, chan->defmodes, chan->deftopic);
	fprintf(fchan, "DESCRIPTION %s\nWELCOME %s\n", chan->description, chan->welcome);
	fprintf(fchan, "OPTIONS %d %d %d %d %d %d %d %d\n", CSetWelcome(chan), CStrictOp(chan), CLockTopic(chan), CNoBans(chan), CNoOps(chan), chan->banlevel, chan->bantype, (chan->flag & C_AUTOINVITE));
	fprintf(fchan, "MOTD %s\nURL %s\nSUSPEND %s\n", chan->motd, chan->url, chan->suspend);

	fclose(fchan);
	strlwr(nchan);
	sprintf(buff, "database/bans/%s", nchan);

	if(!chan->banhead || !(fchan = fopen(buff, "w"))) return;

	for(ban = chan->banhead;ban;ban=ban->next)
		fprintf(fchan, "%s %s %ld %ld %d :%s\n", ban->mask, ban->de, ban->debut, ban->fin, ban->level, ban->raison);

	fclose(fchan);
	return;
}

void write_bans(aChan *chan)
{
	FILE *fchan;
	aBan *ban;
	char nchan[200], buff[230];

	conv_char(chan->chan, nchan);
	strlwr(nchan);
	snprintf(buff, 230, "database/bans/%s", nchan);

	if(!chan->banhead) // au lieu d'crire un fichier pour keud, on peut kiter direct, et supprimer le fichier
	{		      // si il existe pour faire le mnage :p --Progs
		remove(buff);
		return;
	}

	if(!(fchan = fopen(buff, "w"))) return;
	for(ban = chan->banhead;ban;ban=ban->next)
		fprintf(fchan, "%s %s %ld %ld %d :%s\n", ban->mask, ban->de, ban->debut, ban->fin, ban->level, ban->raison);

	fclose(fchan);
	return;
}

void load_chans()
{
	FILE *fp, *fp1;
	char buff[250], buff1[500], nchan[200], *chan = NULL, *tmp = NULL, chanurl[100];
	char *field = NULL, modes[20], topic[TOPICLEN], defmodes[30], deftopic[TOPICLEN];
	char description[200], welcome[250], suspend[200], motd[250];
	int setwelcome,strictop,banlevel,bantype,locktopic,nobans,noops,autoinvite,flag;
	char *mask=NULL, *de = NULL, *debut = NULL, *fin = NULL, *level=NULL;
	aChan *cc=NULL;

	if(!(fp = fopen(CHANS_FILE, "r")))
	{
		premiere = 1;
		return;
	}
	while(fgets(buff, 250, fp))
	{
		flag = 0;
		strip_newline(buff);
		chan = strtok(buff, " ");
		nchan[0] = '\0';
		conv_char(chan, nchan);
		strlwr(nchan);
		sprintf(buff1, "database/chans/%s", nchan);
		if(!(fp1 = fopen(buff1, "r"))) continue;
		buff1[0] = '\0';
		motd[0] = '\0';

		while(fgets(buff1, 500, fp1))
		{
			strip_newline(buff1);
			if((field = strchr(buff1, ' '))) *field++ = '\0';
			if(!strcmp(buff1, "MODES") && field) strcpy(modes, field);
			if(!strcmp(buff1, "TOPIC") && field) strncpy(topic, field, TOPICLEN);
			if(!strcmp(buff1, "DEFMODES") && field) strncpy(defmodes, field, 30);
			if(!strcmp(buff1, "DEFTOPIC") && field) strncpy(deftopic, field, TOPICLEN);
			if(!strcmp(buff1, "DESCRIPTION") && field) strncpy(description, field, 200);
			if(!strcmp(buff1, "WELCOME") && field) strncpy(welcome, field, 250);
			if(!strcmp(buff1, "OPTIONS") && field)
			{
				autoinvite = 0;
				sscanf(field, "%d %d %d %d %d %d %d %d", &setwelcome, &strictop, &locktopic, &nobans, &noops, &banlevel, &bantype, &autoinvite);
				if(setwelcome) flag |= C_SETWELCOME;
				if(nobans) flag |= C_NOBANS;
				if(noops) flag |= C_NOOPS;
				if(locktopic) flag |= C_LOCKTOPIC;
				if(strictop) flag |= C_STRICTOP;
				if(autoinvite) flag |= C_AUTOINVITE;
			}
			if(!strcmp(buff1, "MOTD") && field) strncpy(motd, field, 250);
			if(!strcmp(buff1, "URL") && field) strncpy(chanurl, field, 100);
			if(!strcmp(buff1, "SUSPEND") && field)
			{
				strncpy(suspend, field, 200);
				cc=add_chan(chan, modes, topic, description, defmodes, deftopic, welcome, suspend, flag, banlevel, bantype, motd, chanurl);
			}
			field[0] = '\0';
		}
		fclose(fp1);
		sprintf(buff1, "database/bans/%s", nchan);
		if(!(fp1 = fopen(buff1, "r"))) continue;
		buff1[0] = '\0';
		while(fgets(buff1, 500, fp1))
		{
			strip_newline(buff1);
			tmp = strchr(buff1, ':');
			if (*tmp == ':') tmp++;

			mask = strtok(buff1, " ");
			de = strtok(NULL, " ");
			debut = strtok(NULL, " ");
			fin = strtok(NULL, " ");
			level = strtok(NULL, " ");
			add_ban(cc, mask, tmp, de, atol(debut), atol(fin), atoi(level));
		}
		fclose(fp1);
	}
	fclose(fp);
}


void write_chans()
{
	struct chaninfo *regs;

	for(regs = chanhead;regs;regs=regs->next) write_achan(regs);
	return;
}


void write_badchans()
{
	FILE *fp;
	struct badchans *badchan;

	if(!(fp = fopen(BADCHANS_FILE, "w"))) return;

	for(badchan = badchead;badchan;badchan=badchan->next)
		fprintf(fp, "%s :%s\n", badchan->chaine, badchan->raison);

	fclose(fp);
	return;
}

void load_badchans()
{
   FILE *fp;
   char buff[300], *chaine, *raison = NULL;

   if(!(fp = fopen(BADCHANS_FILE, "r"))) return;
   while(fgets(buff, 300, fp) != NULL)
   {
	   strip_newline(buff);
	   if((raison = strchr(buff, ':'))) *raison++ = '\0';
	   chaine = strtok(buff, " ");
	   add_abadchan(chaine, raison);
   }
   fclose(fp);
}

void write_badnicks()
{
	FILE *fp;
	struct badnicks *badnick;

	if(!(fp = fopen(BADNICKS_FILE, "w"))) return;

	for(badnick = badnhead;badnick;badnick=badnick->next)
		fprintf(fp, "%s\n", badnick->chaine);

	fclose(fp);
	return;
}

void load_badnicks()
{
	FILE *fp;
	char buff[100];

	if(!(fp = fopen(BADNICKS_FILE, "r"))) return;

	while(fgets(buff, 100, fp))
	{
		strip_newline(buff);
		add_abadnick(buff);
	}
	fclose(fp);
}

void write_cmds()
{
	FILE *fp;
	int i = 0;
	if(!(fp = fopen(CMDS_FILE, "w"))) return;

	while(cs_cmds[i].cmd[0] != '\0')
	{
		if(cs_cmds[i].cmd[0] != '\001')
		  fprintf(fp, "%s %s %d %d %d\n", cs_cmds[i].realcmd[0] != '\0' ? cs_cmds[i].realcmd : cs_cmds[i].cmd, cs_cmds[i].cmd, cs_cmds[i].level ,cs_cmds[i].disable, cs_cmds[i].used);
		i++;
	}
	fclose(fp);
}

void load_cmds()
{
	FILE *fp, *f;
	char buff[250], realcmd[15], cmd[15],tmp[15], dir[50];
	int level, enable, c = 0, used;

	if(!(fp = fopen(CMDS_FILE, "r"))) return;
	while(fgets(buff, 80, fp) != NULL)
	{
		strip_newline(buff);
		sscanf(buff, "%s %s %d %d %d",realcmd, cmd, &level, &enable, &used);
		while(cs_cmds[c].cmd[0] == '\001')
			c++;
		if(!strcasecmp(cs_cmds[c].cmd, realcmd))
		{
			strcpy(tmp,cs_cmds[c].cmd);
			strupr(tmp);
			snprintf(dir, 50, "syntax/%s", tmp);
			if((f=fopen(dir,"r")))
			{
				fgets(buff,250,f);
				strcpy(cs_cmds[c].syntax, buff);
				fclose(f);
			}
			strcpy(cs_cmds[c].cmd, cmd);
			strcpy(cs_cmds[c].realcmd, realcmd);
			cs_cmds[c].level = level;
			cs_cmds[c].disable = enable;
			cs_cmds[c].used = used;
			c++;
		}
	}
	fclose(fp);
}

#ifdef HAVE_VOTE
void write_votes()
{
   FILE *fp;
   int i;
   extern struct votes vote[20];
   extern int vote_nbprop, vote_actif;
   extern char vote_topic[];

   if(!(fp = fopen(VOTE_FILE, "w"))) return;

   fprintf(fp, "VOTE %d %d :%s\n", vote_actif, vote_nbprop, vote_topic);
   for(i=0;i<=vote_nbprop;i++) fprintf(fp, "PROP %d :%s\n", vote[i].voies, vote[i].prop);
   fclose(fp);
   return;
}

void load_votes()
{
   FILE *fp;
   extern struct votes vote[20];
   extern int vote_nbprop, vote_actif;
   extern char vote_topic[];
   char buff[500], *field = NULL, *tmp = NULL;
   int i=0;

   if(!(fp = fopen(VOTE_FILE, "r"))) return;
   while(fgets(buff, 300, fp))
   {
	strip_newline(buff);
	if((field = strchr(buff, ' '))) *field++ = '\0';
	if(!strcmp(buff, "VOTE") && field)
	{
		tmp = strchr(field, ':');
		if(*tmp==':') tmp++;
		strncpy(vote_topic, tmp, MEMOLEN);
		vote_actif = atoi(strtok(field, " "));
		vote_nbprop = atoi(strtok(NULL, " "));
	}
	if(!strcmp(buff, "PROP") && field)
	{
		tmp = strchr(field, ':');
		if(*tmp==':') tmp++;
		strncpy(vote[i].prop, tmp, MEMOLEN);
		vote[i].voies = atoi(strtok(field, " "));
		strcpy(vote[++i].prop, "end");
	}
   }
   fclose(fp);
}
#endif /* HAVE_VOTE */

void rehash_conf(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int help=getoption("-help", parv, parc, 1, -1);

	if(help)
	{
		int i=0;
		FILE *f;
		char tmp[15], buf[250], dir[50];
		for (; cs_cmds[i].cmd[0] != '\0'; i++)
		{
			while(cs_cmds[i].cmd[0] == '\001') i++;
			strcpy(tmp,cs_cmds[i].cmd);
			strupr(tmp);
			snprintf(dir, 50, "syntax/%s", tmp);
			if((f=fopen(dir, "r")))
			{
				fgets(buf, 250, f);
				strcpy(cs_cmds[i].syntax, buf);
				fclose(f);
			}
		}
		csntc(nick, "Syntaxe reload.");
		return;
	}
	if (load_config(FICHIER_CONF)== (-1))
	{
		csntc(nick, "Impossible d'ouvrir la configuration");
		csntc(nick, "Il est possible qu'une erreur ai t faite dans la configuration, vrifiez.");
		return;
	}
	csntc(nick, "Configuration actualise avec succs");
	return;
}

void write_files(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	write_users();
	write_userlist();
	write_chans();
	write_chanlist();
#ifdef USE_WELCOMESERV
	write_welcome();
#endif
	write_badchans();
	write_badnicks();
	write_cmds();
#ifdef HAVE_VOTE
	write_votes();
#endif
	csntc(nick, "Les fichiers ont bien t crits");
	return;
}

void append_file(char *file, char *ligne)
{
	FILE *fp;
	if((fp=fopen(file,"a")))
	{
		fprintf(fp, "%s\n", ligne);
		fclose(fp);
	}
	return;
}


void showconfig(aNick *nick, aChan *c, int parc, char **parv)
{
	csntc(nick, "Etat des variables de configuration");
	csntc(nick, "Nom du rseau : %s", network);
	csntc(nick, "Nom du serveur des Services : %s", bot.server);
	csntc(nick, "IP du link : %s Port %d:", bot.ip, bot.port);
	csntc(nick, "Numeric : %d", bot.num);
	csntc(nick, "Salon de controle : %s", cs.chan);
	csntc(nick, "Message de quit : %s", quit_msg);
	csntc(nick, "Modes : %s", cs.mode);
	csntc(nick, "Nom du serveur : %s", bot.name);
	csntc(nick, "Message PASDEPERM : %s", pasdeperm);
	csntc(nick, "Salon d'aide : %s", bot.chan);
	csntc(nick, "Temps avant un kill : %d", kill_interval);
	csntc(nick, "Change nick : %s", (ConfFlag & CF_CHANGENICK) ? "OUI" : "NON");
	csntc(nick, "Max LastSeen : %d secondes", maxlastseen);
	csntc(nick, "Admin exempt de flood : %s", (ConfFlag & CF_ADMINEXEMPT) ? "OUI" : "NON");
	csntc(nick, "Kill pour flood : %s", (ConfFlag & CF_KILLFORFLOOD) ? "OUI" : "NON");
	csntc(nick, "Temps d'ignore : %d secondes", ignoretime);
	csntc(nick, "Programme de mail : %s", mailprog);
	csntc(nick, "Host hidding activ : %s", (ConfFlag & CF_HOSTHIDING) ? "OUI" : "NON");
	csntc(nick, "Host cach : %s", HIDDEN_HOST);
	csntc(nick, "XMODE : %s HIDECODER : %s", (ConfFlag & CF_XMODE) ? "OUI" : "NON", (ConfFlag & CF_HIDE_ADML4) ? "OUI" : "NON");
	return;
}
