/* src/moduser.c - Modification des paramtres d'un accs
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: moduser.c,v 1.2 2003/02/21 15:50:23 progs Exp $");

/*
 * generic_moduser
 *
 * parv[1] = #salon
 * parv[2] = option
 * parv[3] = nick
 * parv[4] = argument
 */
void generic_moduser(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   anUser *user;
   anAccess *access, *acces;

   if(!(user = getuserinfo(parv[3])))
   {
	   csntc(nick, NOSUCHUSER, parv[3]);
	   return;
   }

   if(!(access=GetAccessIbyUserI(user,parv[1])))
   {
      csntc(nick, "\002%s\002 n'a pas d'access sur le salon \002%s\002 !", user->nick, parv[1]);
	  return;
   }
   if(!strcasecmp(parv[2], "protect"))
   {
	   access->flag = ToggleFlag(access->flag, A_PROTECT);
	   csntc(nick, "La protection a t %sactive pour \002%s\002 sur le chan \002%s\002.",\
	   AProtect(access) ? "" : "des", user->nick, parv[1]);
	   write_anuser(user);
	   return;
   }
   if(!strcasecmp(parv[2], "autoop"))
   {
   	   if(!strcasecmp(nick->user->nick, parv[3]) && access->level < 100)
	   {
	   	csntc(nick, "Vous n'avez pas access  la commande op");
		return;
	   }
	   access->flag = ToggleFlag(access->flag, A_OP);
   	   csntc(nick, "L'AutoOp a t %sactiv pour \002%s\002 sur le chan \002%s\002.",\
   	   AOp(access) ? "" : "des", user->nick, parv[1]);
	   write_anuser(user);
   	   return;
   }
   if(!strcasecmp(parv[2], "autovoice"))
   {
   	   if(!strcasecmp(nick->user->nick, parv[3]) && access->level < 50)
	   {
	   	csntc(nick, "Vous n'avez pas access  la commande voice");
		return;
	   }
	   access->flag = ToggleFlag(access->flag, A_VOICE);
   	   csntc(nick, "L'AutoVoice a t %sactiv pour \002%s\002 sur le chan \002%s\002.",\
   	   AVoice(access) ? "" : "des", user->nick, parv[1]);
	   write_anuser(user);
   	   return;
   }
   if(!strcasecmp(parv[2], "suspend"))
   {
	   access->flag = ToggleFlag(access->flag, A_SUSPEND);
   	   csntc(nick, "\002%s\002 a t %ssuspendu sur le chan \002%s\002.",\
   	   user->nick, ASuspend(access) ? "" : "des", parv[1]);
	   write_anuser(user);
   	   return;
   }
   if(!strcasecmp(parv[2], "level"))
   {
	   int l;
	   if(parc < 4 || !is_num(parv[4]))
	   {
		   csntc(nick, "Veuillez prciser un level valide.");
		   return;
	   }
	   l = atoi(parv[4]);
	   if(l >= 500)
	   {
		csntc(nick, "Il ne peut pas y avoir deux owners pour un salon");
		return;
	   }
	   if(access->level == 500)
	   {
	   	csntc(nick, "L'owner ne peut pas changer de niveau.");
		return;
	   }
	   if(l < 5 || l > 499)
	   {
		csntc(nick, "Le niveau doit tre compris entre 5 et 499");
		return;
	   }
	   if(!IsAnAdmin(nick->user))/*si c un admin pas de verif pr dep/dest*/
	   {
		   acces = GetAccessIbyUserI(nick->user, parv[1]); /*on recup les infos de l'executant*/
		   if(l >= acces->level)
		   {
			   csntc(nick, "Vous ne pouvez donner un niveau suprieur ou gal au votre.");
			   return;
		   }
		   if(acces->level <= access->level)
		   {
			   csntc(nick, "Vous ne pouvez changer le niveau d'un user de niveau suprieur ou gal au votre.");
			   return;
		   }
		   /*il a pass les tests, on file a l'execution*/

	   }
	   access->level = l;
	   csntc(nick, "Le niveau de \002%s\002 a t chang en \002%d\002 sur \002%s", user->nick, l, access->chan);
	   write_anuser(user);
	   return;
   }
   if(!strcasecmp(parv[2], "info"))
   {
	   if(parc < 4)
	   {
		   csntc(nick, "Veuillez prciser une infoline ou le mot cl 'none' pour la supprimer");
		   return;
	   }
	   if(!strcasecmp(parv[4], "none"))
	   {
		   access->info[0] = '\0';
		   csntc(nick, "L'infoline de \002%s\002 sur \002%s\002 a t supprime.", user->nick, access->chan);
		   return;
	   }
	   parv2msgn(parc, parv, 4, access->info, 199);
	   csntc(nick, "Infoline de \002%s\002 sur \002%s\002 change en: %s", user->nick, access->chan, access->info);
	   write_anuser(user);
	   return;
   }
   csntc(nick, "%s n'est pas une option de moduser valide.", parv[2]);
   return;
}


void moduser_protect(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   parv[2] = "PROTECT";
   if(parc == 2) parv[4] = parv[3];
   parv[3] = nick->user->nick;
   generic_moduser(nick, chaninfo, parc == 2 ? 4 : 3, parv);
   return;
}

void moduser_autoop(aNick *nick, aChan *chaninfo, int parc, char **parv)
{

   parv[2] = "AUTOOP";
   if(parc == 2) parv[4] = parv[3];
   parv[3] = nick->user->nick;
   generic_moduser(nick, chaninfo, parc == 2 ? 4 : 3, parv);
   return;
}

void moduser_autovoice(aNick *nick, aChan *chaninfo, int parc, char **parv)
{

   parv[2] = "AUTOVOICE";
   if(parc == 2) parv[4] = parv[3];
   parv[3] = nick->user->nick;
   generic_moduser(nick, chaninfo, parc == 2 ? 4 : 3, parv);
   return;
}
